import { UAParser } from 'ua-parser-js';
import { Environment } from './enums';
type Options = {
    callbackURL: string;
    updateInterval: number;
    enableWithCredentials: boolean;
    uaParser: UAParser;
    log: (...args: any[]) => void;
    env?: Environment;
};
export declare class WS {
    private readonly appId;
    private socket;
    private uaParser;
    private readonly log;
    private uuid;
    private wsURL;
    private callbackURL;
    private request;
    private readonly updateInterval;
    private enableWithCredentials;
    constructor(appId: string, opts: Options);
    private deviceInfo;
    private reinit;
    private init;
    updateUUID(uuid: string): void;
    logout(): void;
    send(action: any, data: any): void;
    onZeroAuth(): void;
    private handleMessage;
    private dispatchEventAndWsSend;
    private dispatchEvent;
}
export {};
